/* The trick I use for 'basic_text_oprimitive.hpp'
 * Similar stuff could be done for float and long double...
 */

    // The mods I've done in the "save (double)' method:
    void save(const double t)
    {
        // must be a user mistake - can't serialize un-initialized data
        if(os.fail())
            boost::throw_exception(archive_exception(archive_exception::stream_error));
#ifdef BOOST_ARCHIVE_TRICK_FLOATING_NAN_INF 
	if (t == std::numeric_limits<double>::infinity ())
	  {
	    os << '('; // arbitrary ASCII char: open range for
		       // positive values
	  }
	else if (t == -std::numeric_limits<double>::infinity ())
	  {
	    os << ')'; // another one: open range for
		       // negative values
	  }
	else if (t != t) // should one use std::numeric_limits<double>::quiet_NaN?
	  {
	    os << '!'; // yet another one: invalid floating number
	  }
	else
	  {
	    os << std::setprecision(std::numeric_limits<double>::digits10 + 2);
	    os << t;
	  }
#else
	os << std::setprecision(std::numeric_limits<double>::digits10 + 2);
	os << t;
#endif
    }
